#include <iostream>

/* run this program using the console pauser or add your own getch, system("pause") or input loop */


//client [-p:x] [-s:IP] [-n:x] [-o]
//-p:x Remote port to send to
//-s:IP Servers IP address or hostname
//-n:x Number of times to send message
//-o Send messages only; dont receive


//http://www.mycplus.com/source-code/c-source-code/tcp-client-and-server/
/*******************************************************
* MYCPLUS Sample Code - http://www.mycplus.com *
* *
* This code is made available as a service to our *
* visitors and is provided strictly for the *
* purpose of illustration. *
* *
* Please direct all inquiries to saqib at mycplus.com *
*******************************************************/
 
// Module Name: Client.c
//
// Description:
// This sample is the echo client. It connects to the TCP server,
// sends data, and reads data back from the server.
//
// Compile:
// cl -o Client Client.c ws2_32.lib
//
// Command Line Options:
// client [-p:x] [-s:IP] [-n:x] [-o]
// -p:x Remote port to send to
// -s:IP Server's IP address or hostname
// -n:x Number of times to send message
// -o Send messages only; don't receive
//
#include <winsock2.h>
#include <stdio.h>
#include <stdlib.h>
 
#define DEFAULT_COUNT 20
#define DEFAULT_PORT 5150
#define DEFAULT_BUFFER 2048
#define DEFAULT_MESSAGE "This is a test of the emergency \
broadcasting system"
 
char szServer[128], // Server to connect to
szMessage[1024]; // Message to send to sever
int iPort = DEFAULT_PORT; // Port on server to connect to
DWORD dwCount = DEFAULT_COUNT; // Number of times to send message
BOOL bSendOnly = FALSE; // Send data only; don't receive














//--------------------------------------------------------------
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <winsock.h>


using namespace std;

#pragma pack(1)
#include <Windows.h>
#include <WinCrypt.h>

#define    MY_PASS       "NALNARI"           // н
#define    KeyLen        0x0080 * 0x10000    // 128-bit




#define UB2 unsigned short
#define UB4 unsigned int
#define SCHAR signed char
 
#define auth_req_msg 1
#define auth_res_msg 2
#define sql_req_msg 3
#define sql_res_msg 4
#define close_req_msg 5
#define close_res_msg 6
 
 
#define SELECT 1
#define UPDATE 2
#define DELETE 3
 
typedef struct _dgt_auth_req_msg
{
	UB2 msg_type;
	SCHAR db_user[33];
	SCHAR password[33];
	SCHAR program_name[63];
	SCHAR db_name[33];
}dgt_auth_req_msg; 
 
typedef struct _dgt_auth_res_msg
{
	UB2 msg_type;
	UB2 rtn_len;
	SCHAR rtn_msg[257];
}dgt_auth_res_msg; 
 
typedef struct _dgt_sql_req_msg
{
	UB2 msg_type;
	UB4 sql_len;
	SCHAR sql_text[1025];
	UB2 sql_type;
}dgt_sql_req_msg; 
 
typedef struct _dgt_sql_res_msg
{
	UB2 msg_type;
	UB4 rtn_len;
	SCHAR rtn_data[1025];
	UB2 sql_type;
}dgt_sql_res_msg; 
//̷ Ǿ ֽϴ.
//Ŭ̾Ʈ _dgt_auth_req_msg ޼   _dgt_auth_res_msg  ϴ.
// Ǯ   Ŭ̾Ʈ α ó ϰ ޼ ְ ޴ ó   ϴ.
//Ŭ̾Ʈ ʿ



int m_nSock;
char * m_pbuf;
dgt_auth_res_msg res;




//̵ н  Է¹ް ޼ ä  ϴ.    ޼ Դ Ȯϰ  ޼ ϴ.
// Ŀ  Է ޾Ƽ  ޼ ְ   Է  鰪   ۵˴ϴ..


dgt_sql_req_msg   sqlReq;
char m_chSqlText[100];
char m_chSqlType[100];

int m_nRetType;
int m_recvLen;
int m_recvCnt;

dgt_sql_res_msg sqlRes;

//--------------------------------------------------------------







int fnSend_AUTH(int sock, int msg_type, char * db_name, char * db_user, char * password, char * program_name)
{
    printf("fnSend_AUTH()\n");
    _dgt_auth_req_msg autReq;
    autReq.msg_type             = (UB2)msg_type;
    strcpy((char*)autReq.db_name       , db_name     );
    strcpy((char*)autReq.db_user       , db_user     );
    strcpy((char*)autReq.password      , password    );
    strcpy((char*)autReq.program_name  , program_name);

    int size = sizeof(autReq);
	int r = send(sock, (char*)&autReq, size, 0);
    printf("send return       %d\n", r);
	if(r == -1)
	{
	    printf("send fail\n");
	    return -1;
    }
    return 1;
}



int fnSend_SQL(int sock, int msg_type, char * sql_text)
{
    printf("fnSend_SQL()\n");
    _dgt_sql_req_msg sqlReq;
    sqlReq.msg_type      = msg_type;
    sqlReq.sql_len       = strlen(sql_text);
    strcpy((char*)sqlReq.sql_text, sql_text);

    int size = sizeof(sqlReq);
	int r = send(sock, (char*)&sqlReq, size, 0);
    printf("send return       %d\n", r);
	if(r == -1)
	{
	    printf("send fail\n");
	    return -1;
    }
    return 1;
}




char* fnRecv(SOCKET sock)
{
    printf("fnRecv()\n");
    char * pbuf = (char*) malloc (4096);

    int a_recvCnt = 0;
    int a_resLen  = 4096;
    
    int read_size = 1024;
    int struct_size = 0;
	while(a_recvCnt < a_resLen)
	{
        //https://msdn.microsoft.com/ko-kr/library/windows/desktop/ms741621(v=vs.85).aspx
        //int WSAIoctl() 쿡 ̰ Ѵ.
        // sigaction()  select() ϱ⵵ Ѵ. 

		int a_strLen = recv(sock, pbuf + a_recvCnt, read_size, 0);
		if(a_strLen == -1)
		{
			perror("net_Login () error");
			break;
		}
		a_recvCnt += a_strLen;
		
		
        UB2 ub;
        memcpy(&ub, pbuf, 2);
        printf("ub      %x    %d\n", ub, ub);
        printf("a_recvCnt   a_strLen     %d    %d\n", a_recvCnt, a_strLen);


        if(ub == auth_req_msg)
        {
            struct_size = sizeof(_dgt_auth_req_msg);
            printf("auth_req_msg\n");
            return pbuf;
        }
        if(ub == auth_res_msg)
        {
            struct_size = sizeof(_dgt_auth_res_msg);
            printf("_dgt_auth_res_msg\n");
            return pbuf;
        }
        if(ub == sql_req_msg)
        {
            struct_size = sizeof(_dgt_sql_req_msg);
            printf("sql_req_msg\n");
            return pbuf;
        }
        if(ub == sql_res_msg)
        {
            struct_size = sizeof(_dgt_sql_res_msg);
            printf("_dgt_sql_res_msg\n");
            return pbuf;
        }
        
        printf("struct_size    %d\n", struct_size);
        if(a_recvCnt <= struct_size )
        {
            printf("a_recvCnt <= struct_size\n");
            break;
        }
	}

    printf("NULL\n");
    return NULL;
}


void fnMSG_TYPE(char * pbuf)
{
    printf("fnMSG_TYPE()\n");
    if(pbuf == NULL)
    {
        return ;
    }

    UB2 ub;
    memcpy(&ub, pbuf, 2);
    printf("ub      %x    %d\n", ub, ub);

    if(ub == auth_res_msg)
    {
    	dgt_auth_res_msg  res = *(dgt_auth_res_msg *)pbuf;
    	printf("res.msg_type           %d\n", res.msg_type);
    	printf("res.rtn_len            %d\n", res.rtn_len );
    	printf("res.rtn_data           %s\n", res.rtn_msg );
    }
    if(ub == sql_res_msg)
    {
    	_dgt_sql_res_msg  res = *(_dgt_sql_res_msg *)pbuf;
    	printf("res.msg_type           %d\n", res.msg_type );
    	printf("res.rtn_len            %d\n", res.rtn_len  );
    	printf("res.sql_type           %d\n", res.sql_type );
    	printf("res.rtn_data           %s\n", res.rtn_data );
    }
}



void fnIoctlSocket(SOCKET sock)
{
    printf("fnIoctlSocket()\n");
    // ߿ Ʈũ  Ǹ. ߰ ȴ.
    //񵿱    ִ. 
    //https://msdn.microsoft.com/ko-kr/library/windows/desktop/ms738573(v=vs.85).aspx
    u_long iMode=0;
    int iResult = ioctlsocket(sock, FIONBIO, &iMode);
    if (iResult != NO_ERROR)
    {
        printf("ioctlsocket failed with error: %ld\n", iResult);
    }
}

























//
// Function: usage:
//
// Description:
// Print usage information and exit
//
void usage() {
    printf("usage: client [-p:x] [-s:IP] [-n:x] [-o]\n\n");
    printf(" -p:x Remote port to send to\n");
    printf(" -s:IP Server's IP address or hostname\n");
    printf(" -n:x Number of times to send message\n");
    printf(" -o Send messages only; don't receive\n");
    ExitProcess(1);
}

//
// Function: ValidateArgs
//
// Description:
// Parse the command line arguments, and set some global flags
// to indicate what actions to perform
//
void ValidateArgs(int argc, char **argv) {
    int i;
    for(i = 1; i < argc; i++) {
        if ((argv[i][0] == '-') || (argv[i][0] == '/')) {
            switch (tolower(argv[i][1])) {
                // Remote port
                case 'p': if (strlen(argv[i]) > 3) iPort = atoi(&argv[i][3]);
                break; // Server
                case 's': if (strlen(argv[i]) > 3) strcpy(szServer, &argv[i][3]);
                break; // Number of times to send message
                case 'n': if (strlen(argv[i]) > 3) dwCount = atol(&argv[i][3]);
                break; // Only send message; don't receive
                case 'o': bSendOnly = TRUE;
                break;
                default: usage();
                break;
            }
        }
    }
}
 
//
// Function: main
//
// Description:
// Main thread of execution. Initialize Winsock, parse the
// command line arguments, create a socket, connect to the
// server, and then send and receive data.
//
int main(int argc, char **argv) {
    WSADATA wsd;
    SOCKET sClient;
    char szBuffer[DEFAULT_BUFFER];
    int ret, i;
    struct sockaddr_in server;
    struct hostent *host = NULL;
    
    // Parse the command line and load Winsock
    //
    ValidateArgs(argc, argv);
    if (WSAStartup(MAKEWORD(2, 2), &wsd) != 0) {
        printf("Failed to load Winsock library!\n");
        return 1;
    }
    strcpy(szMessage, DEFAULT_MESSAGE);
    
    //
    // Create the socket, and attempt to connect to the server
    //
    sClient = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (sClient == INVALID_SOCKET) {
        printf("socket() failed: %d\n", WSAGetLastError());
        return 1;
    }
    server.sin_family = AF_INET;
    server.sin_port = htons(iPort);
    server.sin_addr.s_addr = inet_addr(szServer);
    
    //
    // If the supplied server address wasn't in the form
    // "aaa.bbb.ccc.ddd" it's a hostname, so try to resolve it
    //
    if (server.sin_addr.s_addr == INADDR_NONE) {
        host = gethostbyname(szServer);
        if (host == NULL) {
            printf("Unable to resolve server: %s\n", szServer);
            return 1;
        }
        CopyMemory(&server.sin_addr, host->h_addr_list[0], host->h_length);
    }
    if (connect(sClient, (struct sockaddr *)&server, sizeof(server)) == SOCKET_ERROR) {
        printf("connect() failed: %d\n", WSAGetLastError());
        return 1;
    }
    

    


//------------
//http://www.cplusplus.com/reference/istream/istream/getline/
//\r\n
char buf[1024];
cin.getline(buf, 1024, '\n');
fnSend_AUTH(sClient, auth_req_msg, buf, "db_user", "password", "program_name");
//------------
char * p;
p = fnRecv(sClient);
fnMSG_TYPE(p);
free(p);
//------------
cin.getline(buf, 1024, '\n');
fnSend_SQL(sClient, sql_req_msg, buf);
//------------
p = fnRecv(sClient);
fnMSG_TYPE(p);
free(p);
//------------



    closesocket(sClient);
    WSACleanup();
    return 1;



    
    // Send and receive data
    //
    for(i = 0; i < dwCount; i++) {
        ret = send(sClient, szMessage, strlen(szMessage), 0);
        if (ret == 0) break;
        else if (ret == SOCKET_ERROR) {
            printf("send() failed: %d\n", WSAGetLastError());
            break;
        }
        printf("Send %d bytes\n", ret);
        if (!bSendOnly) {
            ret = recv(sClient, szBuffer, DEFAULT_BUFFER, 0);
            if (ret == 0)// Graceful close
            break;
            else if (ret == SOCKET_ERROR) {
                printf("recv() failed: %d\n", WSAGetLastError());
                break;
            }
            szBuffer[ret] = '\0';
            printf("RECV [%d bytes]: '%s'\n", ret, szBuffer);
        }
    }
    closesocket(sClient);
    WSACleanup();
    return 0;
}
/************************ End of Client ********************/
