#include <iostream>

/* run this program using the console pauser or add your own getch, system("pause") or input loop */

//server [-p:x] [-i:IP] [-o]
//-p:x Port number to listen on
//-i:str Interface to listen on
//-o Receive only, dont echo the data back

/*******************************************************/
//--------------------------------------------------------------------------//
/*************************** Server ********************/
//
// Module Name: Server.c
//
// Description:
// This example illustrates a simple TCP server that accepts
// incoming client connections. Once a client connection is
// established, a thread is spawned to read data from the
// client and echo it back (if the echo option is not
// disabled).
//
// Compile:
// cl -o Server Server.c ws2_32.lib
//
// Command line options:
// server [-p:x] [-i:IP] [-o]
// -p:x Port number to listen on
// -i:str Interface to listen on
// -o Receive only, don't echo the data back
//
#include <winsock2.h>
 
#include <stdio.h>
#include <stdlib.h>
 
#define DEFAULT_PORT 5150
#define DEFAULT_BUFFER 4096
 
int iPort = DEFAULT_PORT; // Port to listen for clients on
BOOL bInterface = FALSE, // Listen on the specified interface
bRecvOnly = FALSE; // Receive data only; don't echo back
char szAddress[128]; // Interface to listen for clients on
 
 










//--------------------------------------------------------------
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <winsock.h>


using namespace std;

#pragma pack(1)
#include <Windows.h>
#include <WinCrypt.h>

#define    MY_PASS       "NALNARI"           // н
#define    KeyLen        0x0080 * 0x10000    // 128-bit




#define UB2 unsigned short
#define UB4 unsigned int
#define SCHAR signed char
 
#define auth_req_msg 1
#define auth_res_msg 2
#define sql_req_msg 3
#define sql_res_msg 4
#define close_req_msg 5
#define close_res_msg 6
 
 
#define SELECT 1
#define UPDATE 2
//#define DELETE 3
 
typedef struct _dgt_auth_req_msg
{
	UB2 msg_type;
	SCHAR db_user[33];
	SCHAR password[33];
	SCHAR program_name[63];
	SCHAR db_name[33];
}dgt_auth_req_msg; 
 
typedef struct _dgt_auth_res_msg
{
	UB2 msg_type;
	UB2 rtn_len;
	SCHAR rtn_msg[257];
}dgt_auth_res_msg; 
 
typedef struct _dgt_sql_req_msg
{
	UB2 msg_type;
	UB4 sql_len;
	SCHAR sql_text[1025];
	UB2 sql_type;
}dgt_sql_req_msg; 
 
typedef struct _dgt_sql_res_msg
{
	UB2 msg_type;
	UB4 rtn_len;
	SCHAR rtn_data[1025];
	UB2 sql_type;
}dgt_sql_res_msg; 
//̷ Ǿ ֽϴ.
//Ŭ̾Ʈ _dgt_auth_req_msg ޼   _dgt_auth_res_msg  ϴ.
// Ǯ   Ŭ̾Ʈ α ó ϰ ޼ ְ ޴ ó   ϴ.
//Ŭ̾Ʈ ʿ




//̵ н  Է¹ް ޼ ä  ϴ.    ޼ Դ Ȯϰ  ޼ ϴ.
// Ŀ  Է ޾Ƽ  ޼ ְ   Է  鰪   ۵˴ϴ..


dgt_sql_req_msg   sqlReq;
char m_chSqlText[100];
char m_chSqlType[100];

int m_nRetType;
int m_recvLen;
int m_recvCnt;

dgt_sql_res_msg sqlRes;

//--------------------------------------------------------------








int fnSEND_AUTH_RES(int sock, char * rtn_msg)
{
    _dgt_auth_res_msg   autRes;
    autRes.msg_type      = auth_res_msg;
    autRes.rtn_len       = strlen(rtn_msg);
    strcpy((char*)autRes.rtn_msg, rtn_msg);

    int size = sizeof(autRes);
	int r = send(sock, (char*)&autRes, size, 0);
    printf("send return       %d\n", r);
	if(r == -1)
	{
	    printf("send fail\n");
	    return -1;
    }
    return 1;
}



int fnSEND_SQL_RES(int sock, char * sql_text)
{
    _dgt_sql_res_msg    sqlRes;
    sqlRes.msg_type      = sql_res_msg;
    sqlRes.rtn_len       = strlen(sql_text);
    sqlRes.sql_type      = 123;
    strcpy((char*)sqlRes.rtn_data, sql_text);

    int size = sizeof(sqlRes);
	int r = send(sock, (char*)&sqlRes, size, 0);
    printf("send return       %d\n", r);
	if(r == -1)
	{
	    printf("send fail\n");
	    return -1;
    }
    return 1;
}





char* fnRecv(SOCKET sock)
{
    printf("fnRecv()\n");
    char * pbuf = (char*) malloc (4096);

    int a_recvCnt = 0;
    int a_resLen  = 4096;
    
    int read_size = 1024;
    int struct_size = 0;
	while(a_recvCnt < a_resLen)
	{
        //https://msdn.microsoft.com/ko-kr/library/windows/desktop/ms741621(v=vs.85).aspx
        //int WSAIoctl() 쿡 ̰ Ѵ.
        // sigaction()  select() ϱ⵵ Ѵ. 

		int a_strLen = recv(sock, pbuf + a_recvCnt, read_size, 0);
		if(a_strLen == -1)
		{
			perror("net_Login () error");
			break;
		}
		a_recvCnt += a_strLen;
		
		
        UB2 ub;
        memcpy(&ub, pbuf, 2);
        printf("ub      %x    %d\n", ub, ub);
        printf("a_recvCnt   a_strLen     %d    %d\n", a_recvCnt, a_strLen);


        if(ub == auth_req_msg)
        {
            struct_size = sizeof(_dgt_auth_req_msg);
            printf("auth_req_msg\n");
            return pbuf;
        }
        if(ub == auth_res_msg)
        {
            struct_size = sizeof(_dgt_auth_res_msg);
            printf("_dgt_auth_res_msg\n");
            return pbuf;
        }
        if(ub == sql_req_msg)
        {
            struct_size = sizeof(_dgt_sql_req_msg);
            printf("sql_req_msg\n");
            return pbuf;
        }
        if(ub == sql_res_msg)
        {
            struct_size = sizeof(_dgt_sql_res_msg);
            printf("_dgt_sql_res_msg\n");
            return pbuf;
        }
        
        printf("struct_size    %d\n", struct_size);
        if(a_recvCnt <= struct_size )
        {
            printf("a_recvCnt <= struct_size\n");
            break;
        }
	}

    printf("NULL\n");
    return NULL;
}



void fnMSG_TYPE(char * pbuf)
{
    if(pbuf == NULL)
    {
        return ;
    }

    UB2 ub;
    memcpy(&ub, pbuf, 2);
    printf("ub      %x    %d\n", ub, ub);

    if(ub == auth_req_msg)
    {
    	dgt_auth_req_msg  req = *(dgt_auth_req_msg *)pbuf;
    	printf("req.msg_type           %d\n", req.msg_type    );
    	printf("req.db_user            %d\n", req.db_user     );
    	printf("req.password           %s\n", req.password    );
    	printf("req.program_name       %s\n", req.program_name);
    	printf("req.db_name            %s\n", req.db_name     );
    }
    if(ub == sql_req_msg)
    {
    	_dgt_sql_res_msg  res = *(_dgt_sql_res_msg *)pbuf;
    	printf("SQLres.msg_type           %d\n", res.msg_type);
    	printf("SQLres.rtn_len            %d\n", res.rtn_len );
    	printf("SQLres.sql_type           %d\n", res.sql_type);
    	printf("res.rtn_data              %s\n", res.rtn_data);
    }
}



void fnIoctlSocket(SOCKET sock)
{
    // ߿ Ʈũ  Ǹ. ߰ ȴ.
    //񵿱    ִ. 
    //https://msdn.microsoft.com/ko-kr/library/windows/desktop/ms738573(v=vs.85).aspx
    u_long iMode=0;
    int iResult = ioctlsocket(sock, FIONBIO, &iMode);
    if (iResult != NO_ERROR)
    {
        printf("ioctlsocket failed with error: %ld\n", iResult);
    }
}







 
 //
// Function: usage
//
// Description:
// Print usage information and exit
//
void usage()
{
    printf("usage: server [-p:x] [-i:IP] [-o]\n\n");
    printf(" -p:x Port number to listen on\n");
    printf(" -i:str Interface to listen on\n");
    printf(" -o Don't echo the data back\n\n");
    ExitProcess(1);
}


//
// Function: ValidateArgs
//
// Description:
// Parse the command line arguments, and set some global flags
// to indicate what actions to perform
//
void ValidateArgs(int argc, char ** argv)
{
    int i;

    for (i = 1; i < argc; i++) 
    {
        if ((argv[i][0] == '-') || (argv[i][0] == '/')) 
        {
            switch (tolower(argv[i][1]))
            {
            case 'p':
                iPort = atoi((const char *) & argv[i][3]);
                printf("%d\n", iPort);
            break;
            case 'i':
                bInterface = TRUE;
                if (strlen(argv[i]) > 3) 
                strcpy(szAddress, & argv[i][3]);
            break;
            case 'o':
                bRecvOnly = TRUE;
            break;
            default:
                usage();
            break;
            }
        }
    }
}

 
 
 
 
 
 
 
 
//
// Function: ClientThread
//
// Description:
// This function is called as a thread, and it handles a given
// client connection. The parameter passed in is the socket
// handle returned from an accept() call. This function reads
// data from the client and writes it back.
//



DWORD WINAPI ClientThread(LPVOID lpParam) 
{
    SOCKET sock=(SOCKET)lpParam;
    char szBuff[DEFAULT_BUFFER];
    int ret, nLeft, idx;
    

//------------
printf("---------------------------------------\n");
char * p;
p = fnRecv(sock);
fnMSG_TYPE(p);
free(p);
//------------
fnSEND_AUTH_RES(sock, "AUTH_RES_MESSAGE");
//------------
p = fnRecv(sock);
fnMSG_TYPE(p);
free(p);
//------------
fnSEND_SQL_RES(sock, "sql_text");
printf("Ϸ---------------------------------------\n\n");
//------------


closesocket(sock);
return 0;


    
    while(1) 
    {

        // Perform a blocking recv() call
        //
        ret = recv(sock, szBuff, DEFAULT_BUFFER, 0);
        if (ret == 0)// Graceful close
        {
            break;
        }
        else if (ret == SOCKET_ERROR) 
        {
            printf("recv() failed: %d\n", WSAGetLastError());
            break;
        }
        szBuff[ret] = '\0';
        printf("RECV: '%s'\n", szBuff);
        
        //
        // If we selected to echo the data back, do it
        //
        if (!bRecvOnly) 
        {
            nLeft = ret;
            idx = 0;
            
            //
            // Make sure we write all the data
            //
            while(nLeft > 0) 
            {
                ret = send(sock, &szBuff[idx], nLeft, 0);
                if (ret == 0)
                {
                    break;
                }
                else if (ret == SOCKET_ERROR) 
                {
                    printf("send() failed: %d\n", WSAGetLastError());
                    break;
                }
                nLeft -= ret;
                idx += ret;
            }
        }
    }
    return 0;
}







 
//
// Function: main
//
// Description:
// Main thread of execution. Initialize Winsock, parse the
// command line arguments, create the listening socket, bind
// to the local address, and wait for client connections.
//
int main(int argc, char **argv) 
{
    WSADATA wsd;
    SOCKET sListen, sClient;
    int iAddrSize;
    HANDLE hThread;
    DWORD dwThreadId;
    struct sockaddr_in local, client;

    ValidateArgs(argc, argv);
    
    if (WSAStartup(MAKEWORD(2, 2), &wsd) != 0) 
    {
        printf("Failed to load Winsock!\n");
        return 1;
    }
    
    // Create our listening socket
    //
    sListen = socket(AF_INET, SOCK_STREAM, IPPROTO_IP);
    if (sListen == SOCKET_ERROR) 
    {
        printf("socket() failed: %d\n", WSAGetLastError());
        return 1;
    }
    
    // Select the local interface and bind to it
    //
    if (bInterface) 
    {
        local.sin_addr.s_addr = inet_addr(szAddress);
        if (local.sin_addr.s_addr == INADDR_NONE) usage();
    }
    else
    {
        local.sin_addr.s_addr = htonl(INADDR_ANY);
    }
    local.sin_family = AF_INET;
    local.sin_port = htons(iPort);

    if (bind(sListen, (struct sockaddr *)&local, sizeof(local)) == SOCKET_ERROR) 
    {
        printf("bind() failed: %d\n", WSAGetLastError());
        return 1;
    }
    listen(sListen, 8);
    
    //
    // In a continous loop, wait for incoming clients. Once one
    // is detected, create a thread and pass the handle off to it.
    //
    while (1) 
    {
        iAddrSize = sizeof(client);
        sClient = accept(sListen, (struct sockaddr *)&client, &iAddrSize);
        if (sClient == INVALID_SOCKET) 
        {
            printf("accept() failed: %d\n", WSAGetLastError());
            break;
        }
        printf("Accepted client: %s:%d\n", inet_ntoa(client.sin_addr), ntohs(client.sin_port));







        hThread = CreateThread(NULL, 0, ClientThread, (LPVOID)sClient, 0, &dwThreadId);
        if (hThread == NULL) 
        {
            printf("CreateThread() failed: %d\n", GetLastError());
            break;
        }
        CloseHandle(hThread);
    }
    closesocket(sListen);
    WSACleanup();
    return 0;
}









